//--------------------------------------------------
// Night Bird application header
//--------------------------------------------------
// $Revision:   1.33  $
// $Date:   18 May 1994 21:26:08  $
//--------------------------------------------------
#ifndef __NB_VER_H
#include "nb_ver.h"
#endif
#ifndef __OB_BIRD_H
#include "ob_bird.h"
#endif
#ifndef __NB_COLOR_H
#include "nb_color.h"
#endif
#ifndef __OB_GROUN_H
#include "ob_groun.h"
#endif
#ifndef __OB_TREE_H
#include "ob_tree.h"
#endif

// World dimensions
#define ST_X            530  // 5 ft
#define ST_Z            530  // 5 ft
#define CRUISING_ELEV  1400  // 
#define BIRD_ELEV      1000  // 
#define BIRD_SPEED       43  // (mph * 8.75)
#define BACK_DRIFT        3  // 
#define Z_HORIZON     12000  // 100 feet
#define X_HORIZON     12000  // 100 feet
#define TREE_LINE      6000  //  50 feet
#define TREE_FADE      7000  //  50 feet
#define TREE_MIN_HT     600  //   6 feet
#define TREE_MAX_HT    1800  //  12 feet
#define PROG_ZOOM        75  // Normal viewing magnification
#define MSG_ZOOM         45  // Message window magnification

// Color settings
#define COLOR_CHG       800
#define FADE_CHG        100
#define COLOR_MARK  EARTH_DK_BLUE

#define UP                1
#define DOWN             -1
#define WAIT              0
#define LEFT              0
#define RIGHT             1
#define NEAR              0
#define MID               1
#define TIP               2

#define VIEWPORT          1
#define MSGPORT           2
#define TOT_PAGES         2
#define TOT_WINDOWS       1
#define FRAME_RATE       25
#define MESSAGE_WAIT    120

#define ORBIT             0
#define HOVER             1
#define GROUND_VIEW       2
#define VIEW_TYPES        3
#define CHANGE_MIN      400
#define CHANGE_RANGE    100
#define ORBIT_MIN        20
#define ORBIT_RANGE      90
#define ORBIT_SPEED      30

#define get_random(lo, hi) ((long)random(hi - lo + 1) + lo)
extern "C" plot_array(s_point *array, int count, int color, int size);

// Globals
extern Graphics *graphics;
extern Viewer *viewer;    
extern Bird *bird;        
extern Ground *ground;    
extern int view_cnt;
extern int current_view;
extern int first_orbit;
