//----------------------------------------------
// Display the OPUS information
//----------------------------------------------
#include <conio.h>
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <dos.h>
#include <string.h>
#include <graphics.h>
#include <opus.h>
#include <op_graph.h>
#include <op_color.h>
#include <op_view.h>
#include <op_timer.h>
#include "nb_color.h"
#include "nb_app.h"

void center(int y, int color, char *str)
{
  int x_pos = getmaxx() / 2 - (textwidth(str) / 2);
  graphics->print(x_pos, y, color, str);
}

void write_opening_message()
{
  int i, x, y, c;
  int st_y = 150;
  char copyright[80];
  port p;

  // Copyright title
  settextstyle(SMALL_FONT, HORIZ_DIR, 4);
  center(st_y, EARTH_WHITE, "Night Bird -- XYZ++");
  sprintf(copyright, "Copyright (C) 1994, Nicholas Centanni");
  center(st_y += 13, EARTH_MED_GREEN, copyright);
  center(st_y += 12, EARTH_LT_GREEN, "All rights reserved.");
}

void opening_message()
{
  // Clear the screen, then fade out the title colors
  graphics->chg_active_page();
  graphics->clear_port(VIEWPORT, EARTH_BLACK);
  graphics->chg_active_page();
  graphics->clear_port(VIEWPORT, EARTH_BLACK);
  fade_cancel = OFF;
  rgb_fade_out(earth_rgb, 1, EARTH_WHITE, EARTH_MED_GREEN, EARTH_LT_GREEN);

  // Write the message on both pages
  graphics->chg_active_page();
  graphics->clear_port(VIEWPORT, EARTH_BLACK);
  write_opening_message();
  graphics->chg_active_page();
  graphics->clear_port(VIEWPORT, EARTH_BLACK);
  write_opening_message();

  // Fade the title in
  rgb_fade_in(earth_rgb, 32, EARTH_WHITE, 0, 0);
  BIOS_Timer *timer = new BIOS_Timer;
  timer->start();
  for (;!fade_cancel;)
  {
    for (int i = 0; i < 10000; i++);
    timer->stop();
    if (timer->time() > 1.2)
      break;
    if (kbhit())
    {
      fade_cancel = ON;
      break;
    }
  }

  // Fade the copyright in
  rgb_fade_in(earth_rgb, 32, EARTH_MED_GREEN, EARTH_LT_GREEN, 0);
  timer->start();
  for (;!fade_cancel;)
  {
    for (int i = 0; i < 10000; i++);
    timer->stop();
    if (timer->time() > 3.0)
      break;
    if (kbhit())
    {
      fade_cancel = ON;
      break;
    }
  }
  delete timer;

  // Fade the message out
  rgb_fade_out(earth_rgb, 32, EARTH_WHITE, EARTH_MED_GREEN, EARTH_LT_GREEN);

  // Clear the screens then restore the palette
  graphics->chg_active_page();
  graphics->clear_port(VIEWPORT, BLACK);
  graphics->chg_active_page();
  graphics->clear_port(VIEWPORT, BLACK);

  struct palettetype pal;
  getpalette(&pal);
  int i = EARTH_WHITE;
  setrgbpalette(pal.colors[i], earth_rgb[i].red,
                earth_rgb[i].green, earth_rgb[i].blue);
  i = EARTH_MED_GREEN;
  setrgbpalette(pal.colors[i], earth_rgb[i].red,
                earth_rgb[i].green, earth_rgb[i].blue);
  i = EARTH_LT_GREEN;
  setrgbpalette(pal.colors[i], earth_rgb[i].red,
                earth_rgb[i].green, earth_rgb[i].blue);
}
