//--------------------------------------------------
// Header for GROUND object
//--------------------------------------------------
// $Revision:   1.13  $
// $Date:   24 Apr 1994 13:50:48  $
//--------------------------------------------------
#ifndef __OB_GROUN_H
#define __OB_GROUN_H
#ifndef __NB_VER_H
#include "nb_ver.h"
#endif

#ifdef BENCHMARK
#define POINT_BLOCK    400
#define MAX_POINTS    (POINT_BLOCK * 1)
#else
#define POINT_BLOCK     50
#ifdef REGISTERED
#define MAX_POINTS    (POINT_BLOCK * 14)
#else
#define MAX_POINTS    (POINT_BLOCK * 12)
#endif
#endif

// Point of light detail
struct ground_point
{
  char color;
  s_point world;
  s_point pix[2];
};

//------------------------------------------
// Ground class description
//------------------------------------------
class Ground
{
 private:
   ground_point *ground_points;
   int point_count;
   int color_toggle;
   int color_index, prev_color_index;
   int color_cnt, color_fade;
   void start_point(int index);
   void restart_point(int index);
   hsl_color color;

 public:
   int max_points;

   Ground(void);
   ~Ground(void);
   void move(int distance);
   void draw(void);
   void erase(void);
   void start_points(void);
   void add_points(void);
   int get_count(void) { return point_count; }
   int get_max(void) { return max_points; }
   void set_color(void);   
};
#endif
